<?php

////////////////////////////////////////////////////////////////////////////////
// A P I                                                                      //
////////////////////////////////////////////////////////////////////////////////

$priority	= array(0.1,0.2,0.3,0.4,0.5,0.6,0.7,0.8,0.9,1);
$changefreq	= array('always','hourly','daily','weekly','montly','yearly','never');
$directory	= 'http://'.$_SERVER['HTTP_HOST'].'/';

function sm_get_news($chfr='weekly',$pr=0.5) {
 global $priority, $changefreq;	
 $xml      = '';
$directory	= 'http://'.$_SERVER['HTTP_HOST'].'/';
 $articles = new articles();
 foreach (array_keys($articles->getContainers()) as $c){
  if ($c!='#hidden') {
   if($articles->setWorkContainer($c)){
//    $categories = $articles->getCategories();
    foreach	(($articles->getCategories()) as $b) {
     foreach ($articles->getArticles($b['id'],true) as $article){
      $loc  = $directory.'?module=articles&c='.str_replace('#', '%23', $c).'&b='.$b['id'].'&a='.$article['id'];
      $xml .= sm_get_xml($loc,rcms_format_time('Y-m-d', $article['time']),$changefreq[$chfr],$priority[$pr]);
     }; 
	};
   };
  };
 };
 return $xml;
};

function sm_get_gallery($chfr='montly', $pr='0.3') 	{				//add gallery
 global $priority, $changefreq;	
 $xml      = '';
$directory	= 'http://'.$_SERVER['HTTP_HOST'].'/';
$file='';
	if ($dh = opendir(GALLERY_IMAGES_DIR)) {
       while (($file = readdir($dh)) !== false) {
		   $lastmod = filemtime(GALLERY_IMAGES_DIR.$file);
		   if (!is_dir($file)) $xml .= sm_get_xml( $directory . '?module=gallery&id='.$file, rcms_format_time('Y-m-d',$lastmod),$changefreq[$chfr],$priority[$pr]);
       }
       closedir($dh);
   } else echo __('Gallery').':  '.__('Error occured');
	
	return $xml;
};



function sm_get_forum($chfr='daily', $pr='0.4') { 	
 global $priority, $changefreq;	
 $xml      = '';
$directory	= 'http://'.$_SERVER['HTTP_HOST'].'/';
$lastmod = @filemtime(FORUM_PATH.'topic_index.dat');
$forum = new forum();
@$topics = $forum->getFreshTopics($system->config['num_of_latest']);
foreach ($topics as $topic_id) {
$xml .= sm_get_xml( $directory . '?module=forum&action=topic&id='.$topic_id, rcms_format_time('Y-m-d',$lastmod),$changefreq[$chfr],$priority[$pr]);}		
return $xml;
};

function sm_get_filesdb($chfr='montly', $pr='0.1') {
 global $priority, $changefreq;	
 $xml      = '';
$lastmod = @filemtime(DF_PATH.'downloads.dat');
$xml .= sm_get_xml('http://'.$_SERVER['HTTP_HOST'].'/?module=filesdb', rcms_format_time('Y-m-d',$lastmod),$changefreq[$chfr],$priority[$pr]);	
return $xml;
}


function sm_get_xml($loc, $lastmod, $chfr='weekly', $pr='0.5') {       
 $loc = htmlspecialchars($loc); 
 $xml = "\t<url>\n";
 $xml .= "\t\t<loc>$loc</loc>\n";
 $xml .= "\t\t<lastmod>$lastmod</lastmod>\n";
 $xml .= "\t\t<changefreq>" . $chfr . "</changefreq>\n";
 $xml .= "\t\t<priority>" . $pr . "</priority>\n";
 $xml .= "\t</url>\n";
 return $xml;
};

////////////////////////////////////////////////////////////////////////////////
// s h o w                                                                    //
////////////////////////////////////////////////////////////////////////////////

if(!empty($_POST['create']) && !empty($_POST['filename'])){
 $frm = new InputForm ('', 'post', '&lt;&lt;&lt; ' . __('Back')); $frm->show();
 $chday = rcms_format_time('Y-m-d', filemtime(RCMS_ROOT_PATH.'content/stats.dat' ));      					// last change data
 $map  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
 $map .= "<?xml-stylesheet type=\"text/xsl\" href=\"http://".$_SERVER['HTTP_HOST']."/sitemap.xsl\"?>";		//add style
 $map .= "<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
  if (!empty($_POST['index'])) $map .= sm_get_xml($directory.'/index.php',$chday,$changefreq[$_POST['ind_changefreq']],$priority[$_POST['ind_priority']]);																							//add index url
 if (!empty($_POST['articles'])) $map .= @sm_get_news($_POST['art_changefreq'],$_POST['art_priority']);		//add articles
 if (!empty($_POST['forum']))    $map .= sm_get_forum($_POST['for_changefreq'],$_POST['for_priority']);		//add forum topics
 if (!empty($_POST['gallery']))  $map .= sm_get_gallery($_POST['gal_changefreq'],$_POST['gal_priority']);	//add gallery
 if (!empty($_POST['filesdb']))  $map .= sm_get_filesdb($_POST['fdb_changefreq'],$_POST['fdb_priority']);	//add filesdb
 $map .= "</urlset>"; 
 
 $FileName = $_POST['filename']; 
 $handler = fopen($FileName, "wb+"); 
 fwrite($handler, $map);
 fclose($handler);
 @chmod($FileName, 0666); 
 echo  $FileName.'&nbsp;'.__('saved successfully').'<br/>';
  
  if (!empty($_POST['gz'])) {
  $filename = $_POST['filename'].'.gz';
    if (!function_exists("gzencode") ) {
				echo __('Error').'&nbsp;'.$filename.'<br/>';
			}
			$file = gzencode($map);
			$handler = fopen($filename, "wb+"); 
			$fp = fopen($filename,"wb");
			fwrite($fp,$file);
			fclose($fp);
			echo $filename.'&nbsp;'.__('saved successfully').'<br/>';
 }
 if(isset($_POST['robots_txt'])) file_write_contents(RCMS_ROOT_PATH . 'robots.txt', $_POST["robots_txt"]);
 if (!empty($_POST['robots'])) {                           //build robots.txt
 $robotstxt  = 	"User-agent: *\n"; 
 $robotstxt .=	"Disallow:/admin/\n";
 $robotstxt .=	"Disallow:/backups/\n";
 $robotstxt .=	"Disallow:/config/\n";
 $robotstxt .=	"Disallow:/content/\n";
 $robotstxt .=	"Disallow:/system/\n";
 $robotstxt .=	"Disallow:/skins/\n";
 $robotstxt .=	"Disallow:/tools/\n";
 $robotstxt .=	"Disallow:/uploads/\n";
 $robotstxt .=	"Disallow:/admin.php\n";
 $robotstxt .=	"Disallow:/captcha.php\n";
 $robotstxt .=	"Disallow:/common.php\n";
 $robotstxt .=	"Crawl-delay: 3\n";							//timeout 3 sec;
 $robotstxt .=	"Sitemap: http://" . str_replace('./', '',$_SERVER['HTTP_HOST'])."/".str_replace('./', '',$FileName);
 $robots  = RCMS_ROOT_PATH.'robots.txt';  
 $handler = fopen($robots, "wb+");
 fwrite($handler, $robotstxt);
 fclose($handler);
 @chmod($robots, 0666);
 echo $robots.'&nbsp;'.__('saved successfully').'<br/>';
 }
 echo __('Done').'<br/>';
 echo __('Look at').'&nbsp;<a href="'.$_POST['filename'].'" target="_blank"> sitemap.xml  </a> &nbsp;<br/>';
 if (!empty($_POST['gz'])) { 
 echo '<a href="http://www.google.com/webmasters/tools/ping?sitemap=http://' . str_replace('./', '',$_SERVER['HTTP_HOST']).'/'.str_replace('./', '',$_POST['filename'].'.gz').'" target="_blank">'.__('Send sitemap.xml.gz to Google').'</a><br/>';
  }
} else {
echo  __('Sitemap will be created for all news (except hidden).').'<br/>';
echo  '<a href="http://www.google.com/support/webmasters/bin/answer.py?answer=40318&topic=13450">'.__('Read more about Google Sitemap').'</a>.<br/>';
echo  '<a href="http://www.google.com/webmasters/">'.__('Register here').'</a>.<br/><br/>';
 $frm = new InputForm ('', 'post', __('Submit'), '', '', '', 'mainfrm');
 $frm->addbreak(__('Configuration sitemap.xml'));
 $frm->hidden('create', '1');
 $frm->addrow(__('Content of').' robots.txt',$frm->textarea('robots_txt', @file_get_contents(RCMS_ROOT_PATH. 'robots.txt'), 80, 10), 'top');
 $frm->addrow(__('Build new').' robots.txt. ', $frm->checkbox('robots', 'true', __('Check if you build robots.txt first time'), false));
 $frm->addrow(__('Index'),$frm->checkbox('index', 'true', __('Add'), 'top').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('ind_priority', $priority,6).__('Priority').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('ind_changefreq', $changefreq,2).__('Changefreq')); 
 $frm->addrow(__('Articles'),$frm->checkbox('articles', 'true', __('Add'), 'top').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('art_priority', $priority,4).__('Priority').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('art_changefreq', $changefreq,3).__('Changefreq')); 
 $frm->addrow(__('Forum'),$frm->checkbox('forum', 'true', __('Add'), 'top').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('for_priority', $priority,3).__('Priority').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('for_changefreq', $changefreq,2).__('Changefreq')); 
 $frm->addrow(__('Gallery'),$frm->checkbox('gallery', 'true', __('Add'), 'top').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('gal_priority', $priority,2).__('Priority').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('gal_changefreq', $changefreq,4).__('Changefreq')); 
 $frm->addrow(__('Categories of files'),$frm->checkbox('filesdb', 'true', __('Add'), 'top').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('fdb_priority', $priority,0).__('Priority').'&nbsp;&nbsp;&nbsp;'.$frm->select_tag('fdb_changefreq', $changefreq,4).__('Changefreq')); 
 $frm->addrow(__('Pack file to').'&nbsp;sitemap.xml.gz',$frm->checkbox('gz', 'true', __('Build new'), true));
 $frm->addrow(__('Filename'), $frm->text_box('filename', RCMS_ROOT_PATH.'sitemap.xml'));
 $frm->show(); 
};
?>