<?php

////////////////////////////////////////////////////////////////////////////////
// A P I                                                                      //
////////////////////////////////////////////////////////////////////////////////

function sm_get_news() {

 $url      = 'http://'.$_SERVER['HTTP_HOST'].'/';
 $xml      = '';

 $articles = new articles();
 
 foreach (array_keys($articles->getContainers()) as $c){
  if ($c!='#hidden') {
   if($articles->setWorkContainer($c)){
    $categories = $articles->getCategories();
    foreach($categories as $b) {
     foreach ($articles->getArticles($b['id'],true) as $article){
      $loc  = $url.'?module=articles&c='.str_replace('#', '%23', $c).'&b='.$b['id'].'&a='.$article['id'];
      $xml .= sm_get_xml($loc,rcms_format_time('Y-m-d', $article['time']));
     };
	  };
   };
  };
 };

 return $xml;
 
};

function sm_get_xml($loc, $lastmod) {

 $loc = htmlspecialchars($loc);
/*
 $xml = "\t<url>\n";
 $xml .= "\t\t<loc>$loc</loc>\n";
 $xml .= "\t\t<lastmod>$lastmod</lastmod>\n";
 $xml .= "\t</url>\n";
*/
 $xml = "\t<url>\n";
 $xml .= "\t\t<loc>$loc</loc>\n";
 $xml .= "\t\t<news:news>\n";
 $xml .= "\t\t\t<news:publication_date>$lastmod</news:publication_date>\n";
 //$xml .= "\t\t\t<news:keywords>$keywords</news:keywords>\n"; 
 $xml .= "\t\t</news:news>\n";
 $xml .= "\t</url>\n";

 return $xml;

};

function sm_build_map () {
 
 $map  = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<urlset xmlns=\"http://www.sitemaps.org/schemas/sitemap/0.9\">\n";
 $map .= "\txmlns:news=\"http://www.google.com/schemas/sitemap-news/0.9\">\n";
 $map .= sm_get_news();
 $map .= "</urlset>";

 return $map;

};

function sm_save_map ($FileName) {

 $sitemap = sm_build_map();
  
 $handler = fopen($FileName, "wb+"); 
 fwrite($handler, $sitemap);
 fclose($handler);
 @chmod($FileName, 0666);

};

////////////////////////////////////////////////////////////////////////////////
// s h o w                                                                    //
////////////////////////////////////////////////////////////////////////////////

if(!empty($_POST['create']) && !empty($_POST['filename'])){
 $frm = new InputForm ('', 'post', '&lt;&lt;&lt; ' . __('Back')); $frm->show();
 sm_save_map($_POST['filename']);
 print(' ');
} else {

 print('     ,  .<br>  SiteMap  Google <a href="http://www.google.com/support/webmasters/bin/answer.py?answer=40318&topic=13450"></a>.<br>   <a href="http://www.google.com/webmasters/"></a><br><br>');
 
 $frm = new InputForm ('', 'post', __('Submit'), '', '', '', 'mainfrm');

 $frm->hidden('create', '1');

 $frm->addrow(__('Filename'), $frm->text_box('filename', RCMS_ROOT_PATH.'sitemap.xml'));

 $frm->show(); 
 
};
 
?>